<?php
/**
 * Basic Functions
 *
 * DISCLAIMER
 *
 * Do not edit or add directly to this file if you wish to upgrade MarketPlace to newer
 * versions in the future. If you wish to customise MarketPlace for your needs, modify on your own risk.
 *
 * @package    WpForest
 * @category   Functions
 * @author     Vikas Bhardwaj
 * @copyright  Copyright (c) 2011 gayatri Corp.
 * @license    http://themeshive.com/license/wp-forest
 */
 /**
  * Defines all required functions and veriables
  * @param string  
  * @return string
  * @since 1.0
  */
DEFINE("THEME_VERSION", "1.0");
DEFINE("THEME_RELEASE_DATE", "21 April 2012");	
define('UPLOAD', get_template_directory_uri().'/upload');

/**
	 * Admin setting pannels
	 * @since 1.0
 */
require_once('admin/options_base.php');
require_once('admin/function_base.php');
require_once('admin/setting.php');
require_once('admin/charts.php');

//require_once('setting/setting.php');
//require_once('setting/user-options.php');
require_once('admin/withdraw-request.php');
require_once('admin/history-setting.php');
require_once('admin/user-options.php');
if(file_exists('function/module/ipn-handler.php')){
   echo "file exist";
} else {
  function file_not_available(){
$msg = __('Some of your core files are not available in this theme please download a new version of theme or upload a properly ziped file.');
echo "<div class='error fade'><p>$msg</p></div>";
							
}
}
add_action('admin_notices', 'file_not_available');

require_once('users/login-register.php');
require_once( 'functions/scripts.php');
require_once( 'users/navigation.php');
require_once('lib/sql.php');
require_once('functions/development/functions.php');
/**
 * Include all classes, drop-ins and shipping/gateways modules
 */
$include_files = array();
//admin dashboard
$include_files = array_merge($include_files, (array) glob( dirname(__FILE__)."/class/*.php" ));
// Modules
$include_files = array_merge($include_files, (array) glob( dirname(__FILE__)."/functions/modules/*.php" ));
// Extras
$include_files = array_merge($include_files, (array) glob( dirname(__FILE__)."/functions/extra/*.php" ));
// Drop-ins (addons, premium features etc)
$include_files = array_merge($include_files, (array) glob( dirname(__FILE__)."/drop-ins/*.php" ));
if ($include_files) :
foreach($include_files as $filename) :
if (!empty($filename) && strstr($filename, 'php')) :
include_once($filename);
endif;
endforeach;
endif;

/**
 * Registers all essential functions in initiation of theme
 * @since 1.0
 */
 session_start();
add_action('init', 'MarketItemTheme_create_post_type' );
//add_action('init', 'createhtaccess' );	
add_action("template_redirect", 'MarketItemTheme_template_redirect');
add_action('generate_rewrite_rules', 'MarketItemTheme_rewrite_rules' );
add_action('query_vars', 'MarketItemTheme_add_query_vars');  
add_action( 'widgets_init', 'WpForest_add_sidebars' );
//add_action('init', 'comment_posts_per_page' );	

/**
 * Defines the pricing structure
 * @param string  - pricing
 * @return string
 * @since 1.0
 */
function MarketItemTheme_currency()
{
$c = trim(get_option('WpForest_currency_symbol'));
if(empty($c))
return get_option('MarketItemTheme_currency');
return $c;	
}

function WpForest_currency()
{
$c = trim(get_option('WpForest_currency_symbol'));
if(empty($c))
return get_option('MarketItemTheme_currency');
return $c;	
}

 /*function comment_posts_per_page() {
query_comment( "limit=2" ); 
}
 add_filter( 'pre_get_comment', 'comment_posts_per_page' );
 
/**
 * registers all custom queries for extensibility of theme
 * @param string  - $public_query_vars
 * @return string
 * @since 1.0
 */
function MarketItemTheme_add_query_vars($public_query_vars) 
{  
$public_query_vars[] = 'my_custom_page_type'; 
$public_query_vars[] = 'step'; 
$public_query_vars[] = 'my_second_page';
$public_query_vars[] = 'third_page';
$public_query_vars[] = 'username';
$public_query_vars[] = 'pid';
$public_query_vars[] = 'post_id';
$public_query_vars[] = 'diposit';
$public_query_vars[] = 'page';
$public_query_vars[] = 'aff';
//$public_query_vars[] = 'comment';

return $public_query_vars;  
}
/**
 * Runs when post is published from draft, underreview
 * @param string  - $post
 * @return 
 * @since 1.0
 */
function WpForest_run_when_post_published($post)
{
if($post->post_type == 'MarketItem'):
update_post_meta($post->ID, 'under_review', "0");
$user 		= get_userdata($post->post_author);
$user_email = $user->user_email;
	
$message = sprintf(__('Your MarketItem (%s) has been posted on the website<br/>
See the MarketItem here: <a href="%s">%s</a>', 'WpForest'), $post->post_title, get_permalink($post->ID),  $post->post_title );
					
sitemile_send_email($user_email, sprintf(__('Your new MarketItem has been approved - %s', 'WpForest'), $post->post_title), $message);
endif;
}

add_action('new_to_publish', 'WpForest_run_when_post_published',10,1);
add_action('draft_to_publish', 'WpForest_run_when_post_published',10,1);
add_action('pending_to_publish', 'WpForest_run_when_post_published',10,1);

/**
 * Evaluates the permalink structure and add admin notices 
 * @return string
 * @since 1.0
 */
function WpForest_admin_notices(){
$msg = sprintf( __( 'You need to set your <a href="%1$s">permalink custom structure</a> to contain <b>/&#37;postname&#37;/</b> before WP Forest will work properly.', '' ), 'options-permalink.php' );
echo "<div class='error fade'><p>$msg</p></div>";
							
}
if ( !stristr( get_option( 'permalink_structure' ), '%postname%' ) ) {
add_action('admin_notices', 'WpForest_admin_notices');
} 

function count_user_posts_by_type($userid, $post_type='market-item') {
 global $wpdb;
 $where = get_posts_by_author_sql($post_type, TRUE, $userid);
 $count = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->posts $where" );
 return apply_filters('get_usernumposts', $count, $userid);
}

function the_excerpt_max_charlength($charlength) {
 $excerpt = get_the_excerpt();
 $charlength++;
 if(strlen($excerpt)>$charlength) {
$subex = substr($excerpt,0,$charlength-5);
$exwords = explode(" ",$subex);
$excut = -(strlen($exwords[count($exwords)-1]));
if($excut<0) {
echo substr($subex,0,$excut);
} else {
echo $subex;
}
echo "...";
} else {
echo $excerpt;
}
}

// Don't add the wp-includes/js/comment-reply.js script to single post pages unless threaded comments are enabled
function theme_queue_js(){
if (!is_admin()){
if ( is_singular() AND comments_open() AND (get_option('thread_comments') == 1))
wp_enqueue_script( 'comment-reply' );
}
}
add_action('wp_print_scripts', 'theme_queue_js');

function MarketItem_isValidEmail($email){
return eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$", $email);
}

add_filter('pre_get_posts', 'query_post_type');
function query_post_type($query) {
if(is_category() || is_tag()) {
$post_type = get_query_var('post_type');
if($post_type)
$post_type = $post_type;
else
$post_type = array('post','market-item'); // replace cpt to your custom post type
$query->set('post_type',$post_type);
return $query;
}
}
function add_googleplusone() {
echo '<script type="text/javascript" src="http://apis.google.com/js/plusone.js"></script>';
}
add_action('wp_footer', 'add_googleplusone');
function pinterest_image() {
global $post, $posts;
$first_img = '';
ob_start();
ob_end_clean();
$output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches);
$first_img = $matches [1] [0];
if(empty($first_img)){ //Defines a default image
$first_img = "/images/default.jpg";
}
return $first_img;
}


show_admin_bar(false);  


function prevent_admin_access() {
    if (strpos(strtolower($_SERVER['REQUEST_URI']), '/wp-admin') !== false && !current_user_can('administrator')) {
        wp_redirect(get_option('siteurl').'/my-account/');
    }
}

add_action('init', 'prevent_admin_access', 0);


add_filter( "term_links-category", 'limit_terms');
add_filter( "term_links-item-cat", 'limit_terms');

function limit_terms($val) {
    return array_splice($val, 0, 5);
}




function implement_ajax() {
if(isset($_POST['main_catid']))
			{
			$categories=  get_categories('child_of='.$_POST['main_catid'].'&hide_empty=0&taxonomy=item-cat');
			  foreach ($categories as $cat) {
				$option .= '<option value="'.$cat->term_id.'">';
				$option .= $cat->cat_name;
				$option .= ' ('.$cat->category_count.')';
				$option .= '</option>';
			  }

			  echo '<option value="-1" selected="selected">Select Subcategory</option>'.$option;
			die();
			} // end if
}

add_action('wp_ajax_my_special_action', 'implement_ajax');
add_action('wp_ajax_nopriv_my_special_action', 'implement_ajax');
?>