<?php 
//Meta Box Starts
$prefix = 'WpForest_';
$meta_box = array(
'id' => 'my-meta-box',
'title' => 'Item info and links',
'page' => 'market-item',
'context' => 'normal',
'priority' => 'high',
'fields' => 
array(

array(    
"name" => "Price",
"desc" => "Insert the price.",
"id" => $prefix."price",
"type" => "text",
"std" =>"",
),

array(    
"name" => "Small image",
"desc" => "Insert the small image (size 80X80).",
"id" => $prefix."Image1",
"type" => "text",
"std" =>"",
),

array(
'name' => 'Large Image',
'desc' => 'Insert the large image.',
'id' => $prefix . 'Image2',
'type' => 'text',
'std' => ''
),
array(
'name' => 'Theme Download Link',
'desc' => 'Enter the theme download url.',
'id' => $prefix . 'download-file',
'type' => 'text',
'std' => ''
),

array(
'name' => 'Theme Demo Link',
'desc' => 'Enter the theme demo url.',
'id' => $prefix . 'demo',
'type' => 'text',
'std' => ''
),

array(
'name' => 'Free file',
'desc' => 'Make it free.',
'id' => $prefix . 'make_free',
'type' => 'checkbox',
'std' => ''
),

array(
'name' => 'Featured file',
'desc' => 'Make it Featured file.',
'id' => $prefix . 'featured',
'type' => 'checkbox',
'std' => ''
),

array(
'name' => 'Documentation',
'desc' => 'Select documentation status.',
'id' => $prefix . 'documentation',
'type' => 'select',
'options'=> array('Well Documentation' ,'No Documentation' ),
'std' => ''
),

array(
'name' => 'Layout',
'desc' => 'Select layout status.',
'id' => $prefix . 'layout',
'type' => 'select',
'options'=> array('Fixes' ,'Fluidic' ),
'std' => ''
),

array(
'name' => 'Included Files',
'desc' => 'Enter files included.',
'id' => $prefix . 'files_inc',
'type' => 'text',
'std' => ''
),
array(
'name' => 'Compatible Browsers',
'desc' => 'Enter Browser compatiblity.',
'id' => $prefix . 'browser',
'type' => 'text',
'std' => ''
)
),
);
add_action('admin_menu', 'mytheme_add_box');
// Add meta box
function mytheme_add_box() {
global $meta_box;
add_meta_box($meta_box['id'], $meta_box['title'], 'mytheme_show_box', $meta_box['page'],        $meta_box['context'], $meta_box['priority']);
}
// Callback function to show fields in meta box
function mytheme_show_box() {
global $meta_box, $post;
 // Use nonce for verification
echo '<input type="hidden" name="mytheme_meta_box_nonce" value="', wp_create_nonce(basename(__FILE__)), '" />';
echo '<table class="form-table">';
foreach ($meta_box['fields'] as $field) {
 // get current post meta data
$meta = get_post_meta($post->ID, $field['id'], true);
echo '<tr>',
'<th style="width:20%"><label for="', $field['id'], '">', $field['name'], '</label></th>',
'<td>';

switch ($field['type']) {
case 'text':
echo '<input type="text" name="', $field['id'], '" id="', $field['id'], '" value="', $meta ? $meta : $field['std'], '" size="30" style="width:97%" />',
'<br />', $field['desc'];
break;
case 'textarea':
echo '<textarea name="', $field['id'], '" id="', $field['id'], '" cols="60" rows="4" style="width:97%">', $meta ? $meta : $field['std'], '</textarea>',
'<br />', $field['desc'];
break;
case 'select':
echo '<select name="', $field['id'], '" id="', $field['id'], '">';
foreach ($field['options'] as $option) {
echo '<option', $meta == $option ? ' selected="selected"' : '', '>', $option, '</option>';
}
echo '</select>';
break;		
case 'radio':
foreach ($field['options'] as $option) {
echo '<input type="radio" name="', $field['id'], '" value="', $option['value'], '"', $meta == $option['value'] ? ' checked="checked"' : '', ' />', $option['name'];
}
break;
case 'checkbox':
echo '<input type="checkbox" name="', $field['id'], '" id="', $field['id'], '"', $meta ? ' checked="checked"' : '', ' />';	break;			
}
echo 	'<td>',
'</tr>';
}
echo '</table>';
}
add_action('save_post', 'mytheme_save_data');
// Save data from meta box
function mytheme_save_data($post_id) {
global $meta_box;
// verify nonce
if (!wp_verify_nonce($_POST['mytheme_meta_box_nonce'], basename(__FILE__))) {
		 return $post_id;
}
 // check autosave
if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
return $post_id;
}

// check permissions
if ('page' == $_POST['post_type']) {
if (!current_user_can('edit_page', $post_id)) {
return $post_id;
}
} elseif (!current_user_can('edit_post', $post_id)) {
return $post_id;
}
foreach ($meta_box['fields'] as $field) {
$old = get_post_meta($post_id, $field['id'], true);
$new = $_POST[$field['id']];
if ($new && $new != $old) {
update_post_meta($post_id, $field['id'], $new);		
} elseif ('' == $new && $old) {
delete_post_meta($post_id, $field['id'], $old);
}
}
}
?>