<?php 

/**
 * Custom Posts
 *
 * DISCLAIMER
 *
 * Do not edit or add directly to this file if you wish to upgrade MarketPlace to newer
 * versions in the future. If you wish to customise MarketPlace for your needs, modify on your own risk.
 *
 * @package    WpForest
 * @category    Modules
 * @author       Avinas Bhardwa
 * @copyright   Copyright (c) 2011 gayatri Corp.
 * @license      http://themeshive.com/license/wp-forest
 */
 
 
 /**
  * Create auro draft for post which is yet to be inserted via front end form
  * @param string  - $uid
  * @return inserts Post 
  * @since 1.0
  */
function WpForest_create_auto_draft($uid)
{
$my_post = array();
$my_post['post_title'] 		= 'Auto Draft';
$my_post['post_type'] 		= 'market-item';
$my_post['post_status'] 	= 'auto-draft';
$my_post['post_author'] 	= $uid;
return wp_insert_post( $my_post, true );
}
/**
 * Gets saved autodraft from database
 * @param string  - $uid
 * @return $raw
 * @since 1.0
 */
function WpForest_get_auto_draft($uid)
{
global $wpdb;	
$querystr = "
SELECT distinct wposts.* 
FROM $wpdb->posts wposts where 
wposts.post_author = '$uid' AND wposts.post_status = 'auto-draft' 
AND wposts.post_type = 'market-item' 
ORDER BY wposts.ID DESC LIMIT 1 ";
				
$row = $wpdb->get_results($querystr, OBJECT);
if(count($row) > 0)
{
$row = $row[0];
return $row->ID;
}	
return false;	
}


/**
 * Creates custom post type 
 * @return Custom post type
 * @since 1.0
 */
function MarketItemTheme_create_post_type() {
  
  register_post_type( 'market-item',
array(
'labels' => array(
'name' 			=> __( 'Market Items','WpForest' ),
'singular_name' => __( 'Market Item','WpForest' ),
'add_new' 		=> __('Add New Item','WpForest'),
'new_item' 		=> __('New Item','WpForest'),
'edit_item'		=> __('Edit Item','WpForest'),
'add_new_item' 	=> __('Add New Item','WpForest'),
'search_items' 	=> __('Search Items','WpForest'),	
),
'public' => true,
'menu_position' => 5,
//'register_meta_box_cb' => 'MarketItemTheme_set_metaboxes',
'has_archive' => true,
'rewrite' => true, 
'supports' => array('title','editor','author','thumbnail','excerpt','comments','custom-fields'),
'_builtin' => false,
//  'menu_icon' => $icn,
'publicly_queryable' => true,
'hierarchical' => false 
)
);
 
/**
   * Register Custom taxonomy
   * @since 1.0
   */
	register_taxonomy( 'item-cat', 'market-item', array( 'hierarchical' => true, 'label' => __('Market Categories','WpForest') ) );
	add_post_type_support( 'market-item', 'author' );
	register_taxonomy_for_object_type('post_tag', 'market-item');
	flush_rewrite_rules();

}
 ?>