<?php 
/**
 * Custom Rewrite
 *
 * DISCLAIMER
 *
 * Do not edit or add directly to this file if you wish to upgrade MarketPlace to newer
 * versions in the future. If you wish to customise MarketPlace for your needs, modify on your own risk.
 *
 * @package     WpForest
 * @category     Modules
 * @author        Avinas Bhardwa
 * @copyright    Copyright (c) 2011 gayatri Corp.
 * @license       http://themeshive.com/license/wp-forest
 */
 /**
  * Wordpress does't understand the custom url structure and even can't process custom request from url. So we have to write these rules.
  * @param string  - $wp_rewrite
  * @return Custom Page structure
  * @since 1.0
  */
function MarketItemTheme_rewrite_rules( $wp_rewrite )
{
$new_rules = array( 	
'user-profile/([^/]+)/?$' => 'index.php?my_custom_page_type=user_profile&username='.$wp_rewrite->preg_index(1),
'user-profile/([^/]+)/page/?([0-9]{1,})/?$' => 'index.php?my_custom_page_type=user_profile&username='.$wp_rewrite->preg_index(1)
.'&paged='.$wp_rewrite->preg_index(2),
'purchase-this/?([0-9]{1,})/?$' => 'index.php?my_custom_page_type=purchase-this&post_id='.$wp_rewrite->preg_index(1),
'buy-now-diposit/?([0-9]{1,})/?$' => 'index.php?my_custom_page_type=buy-now-diposit&post_id='.$wp_rewrite->preg_index(1),	//'comment/?([0-9]{1,})/?$' => 'index.php?my_custom_page_type=comment&comment='.$wp_rewrite->preg_index(1),
						
'deposit-pay/?([0-9]{1,})/?$' => 'index.php?my_custom_page_type=deposit-pay&diposit='.$wp_rewrite->preg_index(1),					
'download/?([0-9]{1,})/?$' => 'index.php?my_custom_page_type=download&post_id='.$wp_rewrite->preg_index(1),	
'theme-demo/?([0-9]{1,})/?$' => 'index.php?my_custom_page_type=theme-demo&post_id='.$wp_rewrite->preg_index(1),							
		
'post-new/?$' => 'index.php?my_custom_page_type=post-new&step=1',
'post-new/step/?([0-9]{1,})/?$' => 'index.php?my_custom_page_type=post-new&step='.$wp_rewrite->preg_index(1),
'my-account/?$' => 'index.php?my_custom_page_type=my_account&step=1',
'my-account/([^/]+)/?$' => 'index.php?my_custom_page_type=my_account&paged=1&my_second_page='.$wp_rewrite->preg_index(1),
'my-account/([^/]+)/page/?([0-9]{1,})/?$' => 'index.php?my_custom_page_type=my_account&my_second_page='.$wp_rewrite->preg_index(1)
.'&paged='.$wp_rewrite->preg_index(2),
//'MarketItems/([^/]+)/([^/]+)/page/?([0-9]{1,})/?$' => 'index.php?my_custom_page_type=jbbs&MarketItem_sort='.$wp_rewrite->preg_index(2)
//.'&MarketItem_category='.$wp_rewrite->preg_index(1).'&page='.$wp_rewrite->preg_index(3),			
'my-account/([^/]+)/my-page/([^/]+)/?$' => 'index.php?my_custom_page_type=my_account&my_second_page='.$wp_rewrite->preg_index(1)
.'&third_page='.$wp_rewrite->preg_index(2),
'my-account/([^/]+)/?([0-9]{1,})/?$' => 'index.php?my_custom_page_type=my_account&my_second_page='.$wp_rewrite->preg_index(1)
.'&post_id='.$wp_rewrite->preg_index(2),
'ipn-handler/?$' => 'index.php?my_custom_page_type=ipn-handler',
'ipn_handler_balance/?$' => 'index.php?my_custom_page_type=ipn_handler_balance',
);
$wp_rewrite->rules = $new_rules + $wp_rewrite->rules;
}
function MarketItemTheme_post_new_link()
{
return get_bloginfo('siteurl')."/post-new";		
}
function MarketItemTheme_my_account_link()
{
return get_bloginfo('siteurl')."/my-account";		
}
/**
 * Add termplate redirect to the custom page
 * @param string  - $redirect_page
 * @return Redirected URL
 * @since 1.0
 */
function MarketItemTheme_template_redirect()
{
global $wp;
global $wp_query, $wp_rewrite;

$reditect_page =  $wp_query->query_vars['my_custom_page_type'];
//----------------------------------------------------
if ($reditect_page == "my_account")
{
include(TEMPLATEPATH.'/users/my-account.php');
die();	
}		
if ($reditect_page == "post-new")
{
include(TEMPLATEPATH.'/post-new.php');
die();	
}	
if ($reditect_page == "theme-demo")
{
include(TEMPLATEPATH.'/templates/demos/index.php');
die();	
}
if ($reditect_page == "download")
{
include(TEMPLATEPATH.'/templates/download/download.php');
die();	
}
if ($reditect_page == "comment")
{
include(TEMPLATEPATH.'/custom-comment.php');
die();	
}
if ($reditect_page == "pay_paypal")
{
include(TEMPLATEPATH.'/lib/gateways/paypal.php');
die();	
}	
if ($reditect_page == "user_profile")
{
include(TEMPLATEPATH.'/users/user-profile.php');
die();	
}	
if ($reditect_page == "ipn-handler")
{
include(TEMPLATEPATH.'/lib/gateways/ipn-handler.php');
die();	
}	
if ($reditect_page == "ipn_handler_balance")
{
include(TEMPLATEPATH.'/lib/gateways/ipn_handler_balance.php');
die();	
}	
if ($reditect_page == "purchase-this")
{
include(TEMPLATEPATH.'/lib/purchase-this.php');
die();	
}
if ($reditect_page == "buy-now-diposit")
{
include(TEMPLATEPATH.'/lib/buy-now-diposit.php');
die();	
}	
if ($reditect_page == "deposit-pay")
{
include(TEMPLATEPATH.'/lib/gateways/deposit-pay.php');
die();	
}
}
if(isset($_GET['_ad_delete_pid']))
{
$pid = $_GET['_ad_delete_pid'];
wp_delete_attachment($pid);
exit;
}
 ?>