<?php 
/**
 * Adds Foo_Widget widget.
 */
class Foo_Widget extends WP_Widget {
/**
	 * Register widget with WordPress.
*/
public function __construct() {
parent::__construct(
'foo_widget', // Base ID
'Foo_Widget', // Name
array( 'description' => __( 'A Foo Widget', 'text_domain' ), ) // Args
);
}

/**
	 * Front-end display of widget.
	 *
	 * @see WP_Widget::widget()
	 *
	 * @param array $args     Widget arguments.
	 * @param array $instance Saved values from database.
*/
public function widget( $args, $instance ) {
		extract( $args );
		$title = apply_filters( 'widget_title', $instance['title'] );
		echo $before_widget;
$args = array(
         //'show_option_all'    => ,
        'orderby'            => 'name',
        'order'              => 'ASC',
        'style'              => 'list',
        'show_count'         => 1,
        'hide_empty'         => 1,
        'use_desc_for_title' => 1,
        'child_of'           => 0,
        //'feed'               => ,
        //'feed_type'          => ,
        //'feed_image'         => ,
       // 'exclude'            => ,
       // 'exclude_tree'       => ,
       // 'include'            => ,
       'hierarchical'       => true,
       'title_li'           => '<h2 class="box-heading">'. __('categories').'</h2>',
       'show_option_none'   => __('No categories'),
       'number'             => NULL,
       'echo'               => 1,
       'depth'              => 0,
	   'style'              => 'list',
       'current_category'   => 0,
       'pad_counts'         => 0,
       'taxonomy'           => 'item-cat',
       // 'walker'             => 'Walker_Category'
);
echo '<ul class="category-tree">'.wp_list_categories( $args ).'</ul>';
?>
<?php	
		echo $after_widget;
}
/**
	 * Sanitize widget form values as they are saved.
	 *
	 * @see WP_Widget::update()
	 *
	 * @param array $new_instance Values just sent to be saved.
	 * @param array $old_instance Previously saved values from database.
	 *
	 * @return array Updated safe values to be saved.
	 */
public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['title'] = strip_tags( $new_instance['title'] );
		return $instance;
}

/**
	 * Back-end widget form.
	 *
	 * @see WP_Widget::form()
	 *
	 * @param array $instance Previously saved values from database.
*/
public function form( $instance ) {
if ( isset( $instance[ 'title' ] ) ) {
		$title = $instance[ 'title' ];
}
else {
		$title = __( 'New title', 'text_domain' );
}
?>
<p>
<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:' ); ?></label> 
<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
</p>
<?php 
}
} // class Foo_Widget 
add_action( 'widgets_init', create_function( '', 'register_widget( "foo_widget" );' ) );
?>